<?php
add_action('admin_menu', 'kopa_admin_menu_themes_introduction');

function kopa_admin_menu_themes_introduction() {
    // Kopatheme Introduction Page
    $page_kopa_cpanel_themes_introduction = add_theme_page(
            __('Kopatheme - Premium WordPress Themes and Web Templates', kopa_get_domain()), __('Kopatheme Premium Templates', kopa_get_domain()), 'edit_themes', 'kopa_cpanel_themes_introduction', 'kopa_cpanel_themes_introduction'
    );
    add_action('admin_print_styles-' . $page_kopa_cpanel_themes_introduction, 'kopa_admin_themes_introduction_print_styles');
}

function kopa_admin_themes_introduction_print_styles() {
    wp_enqueue_style('kopa-admin-bootstrap-style', get_template_directory_uri() . '/library/css/bootstrap/css/bootstrap.min.css', array(), null);
    wp_enqueue_style('kopa-admin-bootstrap-responsive-style', get_template_directory_uri() . '/library/css/bootstrap/css/bootstrap-responsive.min.css', array(), null);
    wp_enqueue_style('kopa-admin-themes-introduction-style', get_template_directory_uri() . '/library/includes/upsell/css/themes-introduction.css', array(), null);
}

function kopa_cpanel_themes_introduction() {
    include trailingslashit(get_template_directory()) . '/library/includes/upsell/themes-introduction.php';
}


// update to premium notices
add_action('admin_notices', 'kopa_update_premium_version_notices');

function kopa_update_premium_version_notices() {
    $xml = kopa_get_premium_version_info(KOPA_UPDATE_TIMEOUT);

    $out = '<div class="updated kopa_update_info">';
    $out .= sprintf('<p>Latest premium version of <b>%1$s</b> theme is <b>%2$s</b> - <a href="%3$s">Update Now</a> - <a href="%4$s" target="_blank">View Change Log</a></p>', $xml->name, $xml->version, $xml->download, $xml->changelog);
    $out .= '</div>';

    echo $out;
}


function kopa_get_premium_version_info($interval) {
    $xml = new stdClass();
    $xml->version = '1.0';
    $xml->name = 'WP Nictitate Theme';
    $xml->download = 'kopatheme.com';
    $xml->changelog = '#';

    try {
        $db_cache_field = 'kopa-premium-version-notifier-cache-' . kopa_get_domain();
        $db_cache_field_last_updated = 'kopa-premium-version-notifier-last-updated-' . kopa_get_domain();
        $last = get_option($db_cache_field_last_updated);
        $now = time();

        if (!$last || (( $now - $last ) > $interval)) {
            
            $cache = wp_remote_get( KOPA_PREMIUM_VERSION_URL );

            if ( ! is_wp_error( $cache ) && isset( $cache['body'] ) ) {
                $cache = $cache['body'];
            } else {
                $cache = '';
            }
            
            if ($cache) {
                update_option($db_cache_field, $cache);
                update_option($db_cache_field_last_updated, time());
            }
            $notifier_data = get_option($db_cache_field);
        } else {
            $notifier_data = get_option($db_cache_field);
        }

        $xml = simplexml_load_string($notifier_data);
    } catch (Exception $e) {
        error_log($e);
    }
    return $xml;
}